#define F_CPU 80000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <string.h>

extern char data[50];
#define __PROG_TYPES_COMPAT__
#include <avr/pgmspace.h>
#include "ip_arp_udp_tcp.h"
#include "websrv_help_functions.h"
#include "enc28j60.h"
#include "timeout.h"
#include "net.h"



static uint8_t mymac[6] = {0x4d ,0x4c ,0x47 ,0x4e ,0x46 ,0x43 };	// MAC
static uint8_t myip[4] = {192,168,1,122};						// IP
#define WEBSERVER_VHOST "192.168.1.104"							// Zielhost bzw zielServer
#define MYWWWPORT 80										// Port
static uint8_t gwip[4] = {192,168,1,1};						// Gateway-IP

#define BAUD 9600UL // Baudrate
#define UBRR_VAL ((F_CPU+BAUD*8)/(BAUD*16)-1)

// --- there should not be any need to changes things below this line ---
#define TRANS_NUM_GWMAC 1
static uint8_t gwmac[6];
static uint8_t otherside_www_ip[4]= {192,168,1,104}; // will be filled by dnslookup
//
static char urlvarstr[21];
//
//

#define BUFFER_SIZE 650
static uint8_t buf[BUFFER_SIZE+1];
static uint8_t pingsrcip[4];
static uint8_t start_web_client=0;
static uint8_t web_client_attempts=0;
static uint8_t web_client_sendok=0;
static volatile uint8_t sec=0;
static volatile uint8_t cnt2step=0;
static int8_t dns_state=0;
static int8_t gw_arp_state=0;

 


uint16_t http200ok(void)
{
	return(fill_tcp_data_p(buf,0,PSTR("HTTP/1.0 200 OK\r\nContent-Type: text/html\r\nPragma: no-cache\r\n\r\n")));
}

// prepare the webpage by writing the data to the tcp send buffer
uint16_t print_webpage(uint8_t *buf)
{
	uint16_t plen;
	char vstr[50];//17
	plen=http200ok();
	plen=fill_tcp_data_p(buf,plen,PSTR("<h2>web client status</h2>\n<pre>\n"));
	if (gw_arp_state==1){
		plen=fill_tcp_data_p(buf,plen,PSTR("waiting for GW "));
		mk_net_str(vstr,gwip,4,'.',10);
		plen=fill_tcp_data(buf,plen,vstr);
		plen=fill_tcp_data_p(buf,plen,PSTR(" to answer arp.\n"));
		return(plen);
	}
	plen=fill_tcp_data_p(buf,plen,PSTR("Number of data uploads started by ping: "));
	// convert number to string:
	itoa(web_client_attempts,vstr,10);
	plen=fill_tcp_data(buf,plen,vstr);
	plen=fill_tcp_data_p(buf,plen,PSTR("\nNumber successful data uploads to web: "));
	 //convert number to string:
	itoa(web_client_sendok,vstr,10);
	plen=fill_tcp_data(buf,plen,vstr);
	plen = fill_tcp_data_p(buf,plen,PSTR("\n"));
	plen=fill_tcp_data(buf,plen,data);
	plen=fill_tcp_data_p(buf,plen,PSTR("\n</pre><br><hr>"));

	return(plen);
}



// we were ping-ed by somebody, store the ip of the ping sender
// and trigger an upload to http://tuxgraphics.org/cgi-bin/upld
// This is just for testing and demonstration purpose
void ping_callback(uint8_t *ip){
	uint8_t i=0;
	// trigger only first time in case we get many ping in a row:
	if (start_web_client==0){
		start_web_client=1;
		// save IP from where the ping came:
		while(i<4){
			pingsrcip[i]=ip[i];
			i++;
		}
	}
}

// the __attribute__((unused)) is a gcc compiler directive to avoid warnings about unsed variables.
void browserresult_callback(uint16_t webstatuscode,uint16_t datapos __attribute__((unused)), uint16_t len __attribute__((unused))){
	if (webstatuscode==200){
		web_client_sendok++;
	}
}

// the __attribute__((unused)) is a gcc compiler directive to avoid warnings about unsed variables.
void arpresolver_result_callback(uint8_t *ip __attribute__((unused)),uint8_t transaction_number,uint8_t *mac){
	uint8_t i=0;
	if (transaction_number==TRANS_NUM_GWMAC){
		// copy mac address over:
		while(i<6){gwmac[i]=mac[i];i++;}
	}
}


int main(void){

	/*
	uint16_t dat_p,plen;
	char str[20]; int a = 0;
	for(a=0;a<50;a++){	data[a] = 0;}
	*/
	// Set the clock speed to "no pre-scaler" (8MHz with internal osc or
	// full external speed)
	// set the clock prescaler. First write CLKPCE to enable setting
	// of clock the next four instructions.
	// Note that the CKDIV8 Fuse determines the initial
	// value of the CKKPS bits.
	CLKPR=(1<<CLKPCE); // change enable
	CLKPR=0; // "no pre-scaler"

	uart_init();
	/*
	_delay_loop_1(0); // 60us

	//initialize enc28j60
	enc28j60Init(mymac);
	enc28j60clkout(2); // change clkout from 6.25MHz to 12.5MHz
	_delay_loop_1(0); // 60us
	
	//init_cnt2();
	//sei();

	// Magjack leds configuration, see enc28j60 datasheet, page 11 
	// LEDB=yellow LEDA=green
	//
	// 0x476 is PHLCON LEDA=links status, LEDB=receive/transmit
	// enc28j60PhyWrite(PHLCON,0b0000 0100 0111 01 10);
	enc28j60PhyWrite(PHLCON,0x476);

	
	//init the web server ethernet/ip layer:
	init_udp_or_www_server(mymac,myip);
	www_server_port(MYWWWPORT);

	// register to be informed about incomming ping:
	register_ping_rec_callback(&ping_callback);
	*/
	while(1){
	uart_putc("1");
	/*
		// handle ping and wait for a tcp packet
		plen=enc28j60PacketReceive(BUFFER_SIZE, buf);
		dat_p=packetloop_arp_icmp_tcp(buf,plen);
		if(plen==0){
			// we are idle here trigger arp and dns stuff here
			if (gw_arp_state==0){
				// find the mac address of the gateway (e.g your dsl router).
				get_mac_with_arp(gwip,TRANS_NUM_GWMAC,&arpresolver_result_callback);
				gw_arp_state=1;
			}
			if (get_mac_with_arp_wait()==0 && gw_arp_state==1){
				// done we have the mac address of the GW
				gw_arp_state=2;
			}
			dns_state = 2;
			//----------
			if (start_web_client==1){
				sec=0;
				start_web_client=2;
				web_client_attempts++;
				mk_net_str(str,pingsrcip,4,'.',10);
				urlencode(str,urlvarstr);
				//client_browse_url(PSTR("/cgi-bin/upld?pw=sec&pingIP="),urlvarstr,PSTR(WEBSERVER_VHOST),&browserresult_callback,otherside_www_ip,gwmac);
				//client_browse_url(PSTR("/"),"",PSTR(WEBSERVER_VHOST),&browserresult_callback,otherside_www_ip,gwmac);
				client_browse_url(PSTR("/"),"",PSTR(WEBSERVER_VHOST),&browserresult_callback,otherside_www_ip,gwmac);

			}
			// reset after a delay to prevent permanent bouncing
			if (sec>60 && start_web_client==2){
				start_web_client=0;
			}
			continue;
		}
		if(dat_p==0){ // plen!=0
			// check for incomming messages not processed
			// as part of packetloop_arp_icmp_tcp, e.g udp messages
			continue;
		}
		
		if (strncmp("GET ",(char *)&(buf[dat_p]),4)!=0){
			// head, post and other methods:
			//
			// for possible status codes see:
			// http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html
			dat_p=http200ok();
			dat_p=fill_tcp_data_p(buf,dat_p,PSTR("<h1>200 OK</h1>"));
			goto SENDTCP;
		}
		if (strncmp("/ ",(char *)&(buf[dat_p+4]),2)==0){
			dat_p=http200ok();
			dat_p=print_webpage(buf);//buf
			goto SENDTCP;
			}else{
			dat_p=fill_tcp_data_p(buf,0,PSTR("HTTP/1.0 401 Unauthorized\r\nContent-Type: text/html\r\n\r\n<h1>401 Unauthorized</h1>"));
			goto SENDTCP;
		}
		//
		SENDTCP:
		www_server_reply(buf,dat_p); // send data
		*/
	}
	return (0);
}

ISR( USART_RX_vect )
{

	_delay_ms(1000);
	/* TODO: do sth.  */
	uart_putc("H");
}
